<?php
/*
Plugin Name: Attributor FairShare plugin
Plugin URI: http://fairshare.attributor.com
Description: Attributor FairShare plugin
Version: 1.0
Author: Attributor Corp.
Author URI: http://attributor.com
*/

/*  Copyright 2010 Attributor Corp. (email : fairshare@attributor.com)

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.


	This plugin installs the Attributor FairShare content syndication widget. Please register at http://fairshare.attributor.com before you install this plugin.
	    
*/
?>
<?php 

add_action('activate_attributorwidget/attributor.php', 'attributor_install');
add_action('admin_menu', 'page_field');
add_action('save_post', 'page_save');
add_action('admin_menu', 'attributor_custom');
add_filter('the_content','protect');

/* attributor PLUGIN INSTALL */
function attributor_install()
{
global $wpdb;

//CREATE A TABLE CONTAINING THE PAGES WHICH WILL BE PROTECTED
$table=$wpdb->prefix."attributor";
 $structure = "CREATE TABLE IF NOT EXISTS `". $table."` (
        id INT(9) NOT NULL AUTO_INCREMENT,
		post_id VARCHAR(255) NOT NULL,        
	UNIQUE KEY id (id)
    );";

	$wpdb->query($structure);
}

function page_field()
{
	if( function_exists( 'add_meta_box' )) {
		add_meta_box('attributor', __('Attributor FairShare'), 'post_attributor', 'page', 'advanced', 'core');
		add_meta_box('attributor', __('Attributor FairShare'), 'post_attributor', 'post', 'advanced', 'core');
	}
}

/* BACK-END attributor DISPLAY */
function post_attributor($post) {
global $wpdb;

$page_id=$post->ID;
$table=$wpdb->prefix."attributor";
$structure = "SELECT * FROM `". $table."` WHERE post_id=".$post->ID;

$myrows = $wpdb->get_results($structure);

?>
<input type="checkbox" name="is_checked" id="is_checked" <?php if (count($myrows)>0) echo 'checked'; ?>/>
<label for="is_checked">Show the "FairShare this article" button</label>
<?php
}

/* SAVE attributor STATUS */
function page_save($post_id)
{
global $wpdb;

$table=$wpdb->prefix."attributor";

$delete_structure = "DELETE FROM `". $table."` WHERE post_id=".$post_id;

$wpdb->query($delete_structure);

$status = $wpdb->get_results('SELECT post_status FROM wp_posts WHERE ID='.$post_id);

	//IF WE SET THAT THE POST WILL INCLUDE THE attributor WIDGET
	if(isset($_POST["is_checked"]) && ($status[0]->post_status=='publish'))
	{
		//INSERT INTO THE DATABASE
		$insert_structure = "INSERT INTO `".$table."`(post_id) VALUES (".$post_id.")";

		$wpdb->query($insert_structure);
	}	
}

/* attributor UNINSTALL */
function info_uninstall()
{
global $wpdb;

$table=$wpdb->prefix."attributor";

$structure = "DROP TABLE `". $table."`;";

$wpdb->query($structure);
}

//FUNCTION FOR INSERTING attributor WIDGET INTO SELECTED POSTS
function protect($content )
{
	global $wpdb;
	global $post;
	$table = $wpdb->prefix."attributor";
	
	//VERIFY IF THE POST IS SET TO HAVE attributor WIDGET IN IT
	$is_attributor = $wpdb->get_results('SELECT * FROM '.$table.' WHERE post_id='.$post->ID);
	
	if(count($is_attributor)>0)
	{		
	$result = '<div class="attributor-widget">
		<script type="text/javascript" src="http://widgets.attributor.com/fsw-1.0/fsw/j/fssynwidget-merge.min.js"></script> 
		</div>'.$content;	
	}
	else
	{
		$result = $content;
	}
	
	return $result;
}

function attributor_custom()
{
	add_menu_page('custom', 'Attributor FairShare', 7, "", 'attributor_custom_fct');
}

function attributor_custom_fct()
{
global $wpdb;

if((isset($_POST['save']))&&($_POST['save']=='Save'))
{?>
	<div>Attributor FairShare plugin setting has been updated.</div>
	
	<?php $table = $wpdb->prefix."attributor";
	
	if($_POST['all_checked']=='on')
	{			
		$delete_structure = "DELETE FROM ".$table;
		$wpdb->query($delete_structure);
		
		$insert_structure = "INSERT INTO `".$table."`(post_id) SELECT ID FROM wp_posts WHERE post_status='publish'";

		$wpdb->query($insert_structure);
	}
	else
	{
		$delete_structure = "DELETE FROM ".$table;
		$wpdb->query($delete_structure);
	}
}
?>
	<form method="post" action="">
		<?php
		$table = $wpdb->prefix."attributor";
		$select_pages = $wpdb->get_results('SELECT * FROM wp_posts WHERE post_status="publish"');
		$attributor_pages = $wpdb->get_results('SELECT t1.* FROM wp_posts AS t1 join '.$table.' AS t2 ON t1.ID=t2.post_id WHERE t1.post_status="publish"');
		
		if(count($select_pages)!=count($attributor_pages))
		{
			$check = false;
		}
		else
		{
			$check = true;
		}		
	?>
	<input type="checkbox" style="margin-right:10px;" name="all_checked" id="all_checked" <?php if ($check) echo 'checked'; ?>/>
	<label for="all_checked">Show the "FairShare this article" button on every post/page</label>
	<br/>
	<input type="submit" style="margin-top:30px;" value="Save" id="save" name="save">
	</form>
<?php }
?>